function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import * as React from "react";
import { animate, motion, useMotionValue } from "framer-motion";
var containerStyle = {
  position: "relative",
  width: "100%",
  height: "100%",
  overflowX: "hidden",
  display: "flex"
};
var pageStyle = {
  width: "100%",
  height: "100%",
  display: "inline-block",
  flex: "none"
};
var transition = {
  type: "spring",
  bounce: 0
};
var Contaier = /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement("div", {
  ref: ref,
  style: containerStyle
}, props.children));

var Slider = _ref => {
  var {
    x,
    i,
    onDragEnd,
    children
  } = _ref;
  return /*#__PURE__*/React.createElement(motion.div, {
    style: _extends({}, pageStyle, {
      x,
      left: i * 100 + "%",
      right: i * 100 + "%"
    }),
    drag: "x",
    dragElastic: 0.3,
    onDragEnd: onDragEnd
  }, children);
};

var baseArrowStyle = {
  position: "absolute",
  width: "50px",
  height: "50px",
  backgroundColor: "rgba(0,0,0,0.5)",
  top: "50%",
  transform: "translateY(-50%)",
  borderRadius: "50%",
  color: "#fff",
  fontSize: "20px",
  display: "flex",
  alignItems: "center",
  justifyContent: "center",
  cursor: "pointer"
};

var Arrow = _ref2 => {
  var {
    left = false,
    children,
    onClick
  } = _ref2;
  return /*#__PURE__*/React.createElement("div", {
    onClick: onClick,
    style: _extends({}, baseArrowStyle, {
      left: left ? "20px" : "initial",
      right: !left ? "10px" : "initial"
    })
  }, children);
};

export var Carousel = _ref3 => {
  var {
    children,
    renderArrowLeft,
    renderArrowRight
  } = _ref3;
  var x = useMotionValue(0);
  var containerRef = React.useRef(null);
  var [index, setIndex] = React.useState(0);

  var calculateNewX = () => {
    var _containerRef$current;

    return -index * (((_containerRef$current = containerRef.current) == null ? void 0 : _containerRef$current.clientWidth) || 0);
  };

  var handleEndDrag = (e, dragProps) => {
    var _containerRef$current2;

    var clientWidth = ((_containerRef$current2 = containerRef.current) == null ? void 0 : _containerRef$current2.clientWidth) || 0;
    var {
      offset
    } = dragProps;

    if (offset.x > clientWidth / 4) {
      handlePrev();
    } else if (offset.x < -clientWidth / 4) {
      handleNext();
    } else {
      animate(x, calculateNewX(), transition);
    }
  };

  var childrens = React.Children.toArray(children);

  var handleNext = () => {
    setIndex(index + 1 === childrens.length ? index : index + 1);
  };

  var handlePrev = () => {
    setIndex(index - 1 < 0 ? 0 : index - 1);
  };

  React.useEffect(() => {
    var controls = animate(x, calculateNewX(), transition);
    return controls.stop;
  }, [index]);
  return /*#__PURE__*/React.createElement(Contaier, {
    ref: containerRef
  }, childrens.map((child, i) => /*#__PURE__*/React.createElement(Slider, {
    onDragEnd: handleEndDrag,
    x: x,
    i: i
  }, child)), renderArrowLeft ? renderArrowLeft({
    handlePrev,
    activeIndex: index
  }) : /*#__PURE__*/React.createElement(Arrow, {
    left: true,
    onClick: handlePrev
  }, "\u2190"), renderArrowRight ? renderArrowRight({
    handleNext,
    activeIndex: index
  }) : /*#__PURE__*/React.createElement(Arrow, {
    onClick: handleNext
  }, "\u2192"));
};